
-- load apis
colliders = loadSharedAPI("colliders");
rng = loadSharedAPI("rng");
pnpc = loadSharedAPI("pnpc");

-- screen boundaries
local seL = 0;
local seT = 0;
local seR = 0;
local seB = 0;
local seM = 4;

-- table
local table_object282; -- Bullet

-- variables
local f = 0;

-- colliders
local hitbox_player;

function onLoad()
end

function onLoop()
	if (f % 20 == 0) then
		attack1();
	end
	attack1_step();
	player_create_hitbox();
	screenedge_update();
	object282_collide();
	object282_offbounds();
  
	-- persistent
	f = f + 1;
end

function attack1()
	local density = 5;
	local speed = 8;
	local xx = seL + rng.random(500, 700);
	local yy = seT + rng.random(100, 500);
	local direction = rng.random(360);
	local dir = 0;
	local dirspeed = 1 * (2 * round(rng.random(0, 1)) - 1);
	for i=0,density do
		a = pnpc.wrap(NPC.spawn(282, xx, yy, player.section));
		a.dir = direction + i * 360 / density;
		a.data = { spd = speed, dir = a.dir, dirspd = dirspeed };
		a.speedX = a.data.spd * math.cos(math.rad(a.data.dir));
		a.speedY = a.data.spd * math.sin(math.rad(a.data.dir));
	end
end

function attack1_step()
	for k,v in pairs(findnpcs(282, player.section)) do
	    local w = pnpc.getExistingWrapper(v);
	    w.data.dir = w.data.dir + w.data.dirspd;
		v.speedX = w.data.spd * math.cos(math.rad(w.data.dir));
		v.speedY = w.data.spd * math.sin(math.rad(w.data.dir));
	end
end

function player_damage_response()
	player:harm();
end

function player_create_hitbox()
	local xx = player.x;
	local yy = player.y;
	local ww = player.width;
	local hh = player.height;
	hitbox_player = colliders.Box(xx, yy, ww, hh);
	--if (can_draw_hitbox_player) then
	--	hitbox_player:Draw(0xFF00FF99); -- 0xRRGGBBAA up to FF
	--end
end

function object282_collide()
	-- for all object282 in player.section
	for k,v in pairs(findnpcs(282, player.section)) do
    	local hitbox = colliders.Box(v.x, v.y, v.width, v.height);
		-- Hit player
		if (colliders.collide(hitbox_player, hitbox)) then
			player_damage_response();
		end
  	end
end

function object282_offbounds()
	-- for all object282 in player.section
	for k,v in pairs(findnpcs(282, player.section)) do
		-- If outside the screen edge (horizontal)
		if (v.x < seL - seM or seR + seM < v.x) then
			-- and vertical
			if (v.y < seT - seM or seB + seM < v.y) then
				-- Kill with no animation
				v:kill(9);
				
			end
		end
	end
end

function screenedge_update()
	local boundRect = player.sectionObj.boundary;
	seL = boundRect.left;
	seR = boundRect.right;
	seT = boundRect.top;
	seB = boundRect.bottom;
end



function round(num)
	local a = num - math.floor(num);
	if (a >= 0.5) then
		return math.ceil(a);
	else
		return math.floor(a);
	end
end

-- converts seconds to frames
function st(num)
	return round(65 * num);
end
